;Macro para desenhar um biombo com ripas de qualquer dimensão 
;Macro realizado por Cristina Castelo, nº20181364, Turma 3 A 
;Modelação e Visualização Tridimensional em Arquitetura
;Professores Luís Romão e Alex Nogueira 
;Mestrado Integrado em Arquitetura - Faculdade de Arquitetura - UL


;nome do comando
(defun c:biombo ()

(setq ponto (getvar "osmode"))
(setq 3dponto (getvar "3Dosmode"))

;desliga o 3dsnap
(setvar "3Dosmode" 0)

;deixar activado o snap para "endpoint"
(setvar "osmode" 1)

;obter pontos
(setq p1 (getpoint "\nqual o primeiro ponto do rectangulo?"))
(setq p2 (getpoint "\nqual o segundo ponto do rectangulo?"))
(setq nelementos (getint "\nqual o numero de elementos?"))
(setq distancia (/ (- (car p2) (car p1)) nelementos))
(setq altura (getint "\nqual a altura do rectangulo?"))

;desenhar e modelação
(command "rectang" p1 (list 0.2 (- (cadr p2) (cadr p1))))
(command "extrude" (entlast) "" 2)

;repetir elementos
(repeat nelementos
	(command "copy" (entlast) "" p1 (polar p1 0 distancia) ))

;repor o UCS principal e o osnap
(setvar "osmode" ponto)
(setvar "3Dosmode" 3dponto )
)